// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* - ̧		: spi_mem.h
* - ߲		: IAR EWAAVR 3.20c
*
* - xҰ		: avr@atmel.com
*
* - x޲	: SPI̪SRAM(4M޲ĂSPI؂ɑ΂1K޲ĂSRAM𐄏)SĂAVRgpł܂B
*
* - pLq	: AVR107 - SPI^ ޲p{AVRײ
*
* - 		: ޲ : AT25128A/256A, AT25F1024/2048/4096
*				  E^ؑS@\x
*				  EؔzWǂݍ
*				  E߰ޏW
*				  Eݕی쌟o
*				  Eiso
*				  EisWȂݱ
*				  Eԏ
*
* $Revision: 1.3 $
* $Date: Wednesday, March 02, 2005 13:33:00 UTC $
*****************************************************************************/

#ifndef __SPI_MEMORY_H
#define __SPI_MEMORY_H

// (ڑSPI^؂ɑΉs̒߂OĂB)
//#define AT25128A
//#define AT25256A
//#define AT25F1024
//#define AT25F2048
//#define AT25F4096

#if (defined(AT25128A) | defined(AT25256A))
  #define EEPROM_TYPE
#endif

#ifdef EEPROM_TYPE
/* SPI^EEPROM (AT25256A/128A) */
  #define PAGE_SIZE		64		//! ߰ޗe
  #define NB_ADDR_BYTE	2		//!< ڽiKł̱ڽ ޲Đ
  /* ݕی̈ޯ */
  #define WPB_MASK		 0x0C			// ݕیޯĎՕl
  #define NONE			(0x00 << 2)		// ݕیȂ
  #define TOP_QUARTER	(0x01 << 2)		// 1/4̈揑ݕی
  #define TOP_HALF		(0x02 << 2)		// 1/2̈揑ݕی
  #define ALL			(0x03 << 2)		// S̈揑ݕی
  /* ߕ */
  #define WREN	0x06	// ݋
  #define WRDI	0x04	// ݋֎~
  #define RDSR	0x05	// ڼ޽ǂݍ
  #define WRSR	0x01	// ڼ޽
  #define READ	0x03	// ǂݍ
  #define WRITE	0x02	// 
  /* ڽ */
  #ifdef AT25256A
    #define TOPQ_ADDR	0x6000	//!< 1/4̈擪ڽ
    #define HALF_ADDR	0x4000	//!< 1/2̈擪ڽ
    #define TOP_ADDR	0x7FFF	//!< ŏIڽ
  #else
    #define TOPQ_ADDR	0x3000	//!< 1/4̈擪ڽ
    #define HALF_ADDR	0x2000	//!< 1/2̈擪ڽ
    #define TOP_ADDR	0x3FFF	//!< ŏIڽ
  #endif
#else
/* SPI^ׯ (AT25F1024/2048/4096) */
  #define PAGE_SIZE		256		//! ߰ޗe
  #define NB_ADDR_BYTE	3		//!< ڽiKł̱ڽ ޲Đ
  /* ݕی̈ޯ */
  #define WPB_MASK		 0x1C			// ݕیޯĎՕl
  #define NONE			(0x00 << 2)		// ݕیȂ
  #define TOP_EIGHTH	(0x01 << 2)		// 1/8̈揑ݕی
  #define TOP_QUARTER	(0x02 << 2)		// 1/4̈揑ݕی
  #define TOP_HALF		(0x03 << 2)		// 1/2̈揑ݕی
  #define ALL			(0x04 << 2)		// S̈揑ݕی
  /* ߕ */
  #define WREN			0x06	// ݋
  #define WRDI			0x04	// ݋֎~
  #define RDSR			0x05	// ڼ޽ǂݍ
  #define WRSR			0x01	// ڼ޽
  #define READ			0x03	// ǂݍ
  #define PROGRAM		0x02	// 
  #define SECTOR_ERASE	0x52	// 
  #define CHIP_ERASE	0x62	// ߏ
  #define RDID			0x15	// IDǂݍ
  /* ڽ */
  #ifdef AT25F4096
    #define TOP8TH_ADDR	0x70000		//!< 1/8̈擪ڽ
    #define TOPQ_ADDR	0x60000		//!< 1/4̈擪ڽ
    #define HALF_ADDR	0x40000		//!< 1/2̈擪ڽ
    #define TOP_ADDR	0x7FFFF		//!< ŏIڽ
    #define BP2			4            //! ݕی̈Iޯ2ޯĈʒu(AT25F4096̂ݑ)
  #elif (defined(AT25F2048))
    #define TOPQ_ADDR	0x30000		//!< 1/4̈擪ڽ
    #define HALF_ADDR	0x20000		//!< 1/2̈擪ڽ
    #define TOP_ADDR	0x3FFFF		//!< ŏIڽ
  #else
    #define TOPQ_ADDR	0x18000		//!< 1/4̈擪ڽ
    #define HALF_ADDR	0x10000		//!< 1/2̈擪ڽ
    #define TOP_ADDR	0x1FFFF		//!< ŏIڽ
  #endif
#endif

/* ڼ޽ ޯ*/
#define RDY		0	//! Z/Ԏw׸
#define WEN		1	//! ݋ޯ
#define BP0		2	//! ݕی̈Iޯ0
#define BP1		3	//! ݕی̈Iޯ1
#define WPEN	7	//! ĳݕی싖ޯ

/* ϸ */
#define Select_Serial_Memory PORTB=(PORTB & ~(1<<DDB2));	//! /SS=/CS=Lowݒ(^ ߑI)
#define Deselect_Serial_Memory PORTB=(PORTB | (1<<DDB2));	//! /SS=/CS=Highݒ(^ ߔI)
#define Enable_SPI_Interrupt SPCR|=(1 << SPIE)				//! SPI荞݋
#define Disable_SPI_Interrupt SPCR&=~(1 << SPIE)			//! SPI荞݋֎~

/* 萔` */
// Lԋ@\Ԓl
#define INSTRUCTION			0x1		//! ޲đo
#define ADDRESS				0x2		//! ڽ ޲đo
#define DATA				0x4		//! ް ޲đo
#define READY_TO_SEND		0x0		//! ُ(SPI̪])
// Ԓl
#define TRANSFER_STARTED	0x0		//!< ُȂŏݱJn
#define TRANSFER_COMPLETED	0x1		//!< ُȂœǂݍݱ
#define OUT_OF_RANGE		0xFD	//!< p\͈ؔ͊Oڽ
#define DATA_WR_PROTECTED	0xFE	//!< ݕیɂ鏑ݱ~
#define BUSY				0xFF	//!< SPI؂܂SPI̪Z
// s
#define WRITE_PROTECTED		0x1		//!< ݕیʒuƱڽv
#define WRITE_ALLOWED		0x0		//!< ݕی̈Oڽ(݉)
#define HW_PROTECTED		0x2		//!< ʰ޳ݕی(/WP=Low)

#ifdef EEPROM_TYPE
  static int address;				// ؂̎wǂݏڽ
  char TestWriteProtect(int address, int StatusRegister);
  char GetCharArray(int address, int nb_of_byte, char* destination);
  char PutCharArray(int start_add, char nb_of_byte, char* source); 
  char GetChar(int address, char *data);
  char PutChar(int address, char data);
#else
  static unsigned long address;		// ؂̎wǂݏڽ
  char TestWriteProtect(unsigned long address, int StatusRegister);
  char GetCharArray(unsigned long address, unsigned long nb_of_byte, char* destination);
  char PutCharArray(unsigned long start_add, char nb_of_byte, char* source); 
  char GetChar(unsigned long address, char *data);
  char EraseChip(void);
  char EraseSector(unsigned long long_add);
  char GetMemID(char *MemId);
#endif

/* ʑSϐ */
static char state;		//! ݱ̒iKԒl
static char nb_byte;	//! ݎ:޲Đ-1Aǂݍݎ:ǂݍ޲Đ
static char byte_cnt;	//! ɓǂݏꂽ޲Đ
static char *data_ptr;	//! Mޯ̧̈ʒuwq
static char glb_char;	//! PutChar֐1޲Ă̑Mޯ̧Ǝgp

/* ʊ֐^錾 */
void init_spi_master();
char spi_transfer(char data);
char WriteStatusRegister(char StatusRegister);
char GetStatusRegister(char *status);
char WriteCommand(char StatusRegister);
char SetWriteProtectedArea(char area);

#endif // __SPI_MEMORY_H
